
#!/bin/bash

cd /var/www/html/socket/
apt update
apt upgrade -y
apt install ffmpeg -y
apt-get install -y libgbm-dev

wget https://www.johnvansickle.com/ffmpeg/old-releases/ffmpeg-4.4.1-amd64-static.tar.xz
tar xvf ffmpeg-4.4.1-amd64-static.tar.xz
rm ffmpeg-4.4.1-amd64-static.tar.xz

/usr/bin/pm2 stop /var/www/html/socket/mikrowisp.js
/usr/bin/pm2 delete /var/www/html/socket/mikrowisp.js
pm2 save --force
/usr/bin/pm2 save --force

a2enmod proxy
a2enmod proxy_http
a2enmod proxy_balancer
a2enmod lbmethod_byrequests
a2enmod proxy_wstunnel
a2enmod proxy_connect

for file in /etc/apache2/sites-available/*
do
   if grep -q 'localhost:3005' $file
then
echo "Instalado"
else
proxy="RewriteEngine On\n\
RewriteCond %{REQUEST_URI} ^\/socket.io          [NC]\n\
RewriteCond %{QUERY_STRING} transport=websocket [NC]\n\
RewriteRule \/(.*) ws:\/\/localhost:3005\/\$1        [P,L]\n\
ProxyPass \/socket.io http:\/\/localhost:3005\/socket.io\n\
ProxyPassReverse \/socket.io http:\/\/localhost:3005\/socket.io\n\
<\/VirtualHost>\n"

sed -i "s/<\/VirtualHost>/$proxy/" $file
fi

done


systemctl restart apache2
apt install xz-utils -y
wget https://nodejs.org/dist/latest-v22.x/node-v22.5.1-linux-x64.tar.xz
tar -C /usr/local --strip-components 1 -xJf node-v22.5.1-linux-x64.tar.xz
rm node-v22.5.1-linux-x64.tar.xz
npm install -g npm@latest
npm install -g npm
npm update
npm install
npm remove pm2 -g
chown -R www-data:www-data /var/www/html/
clear

history -cw || exit 1

echo "                                                                                     "
echo "                 UPDATE FINALIZADO PUEDES CONTINUAR VIA WEB                          "
echo "                                                                                     "